Bug 124116 - mount --bind works, then later the directory contents diverge
mount --bind works, then later the directory contents diverge
Status: CLOSED WONTFIX
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
9
i386 Linux
medium Severity high
: ---
: ---
Assigned To: Arjan van de Ven
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-05-24 04:18 EDT by Jeff Maurer
Modified: 2007-04-18 13:07 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-30 11:41:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
sanitized transcript of shell output for initial discovery of the problem (4.12 KB, text/plain)
2004-05-24 04:20 EDT, Jeff Maurer
no flags Details

  None (edit)
Description Jeff Maurer 2004-05-24 04:18:33 EDT
Description of problem:
Loopback mount of a directory tree works as expected for a long time
(over seventy days of uptime in this case), then for some unknown
reason the directory contents diverge: the original location displays
the (properly) updated files, yet the loopback-mount location
('path_to_B' in the case of 'mount --bind /path_to_A /path_to_B') does
NOT contain the updated files; rather, it contains a slightly (half a
day perhaps?) stale listing of the files, and subsequent updates on
files in /path_to_A does not affect files in /path_to_B.  The 'mount'
command reports that the directory is still properly loopback-mounted,
and all files except for the recently updated ones appear in both
/path_to_A and /path_to_B as expected.  If I manually unmount the
loopback-mount, /path_to_B displays no files at all (as expected), so
the mount was definitely still active.

Unfortunately this problem occurred on a production webserver, so I
could not spend much time investigating the problem at the time it
happened.  I ran 'umount /path_to_B ; mount --bind /path_to_A
/path_to_B' and the behavior returned to normal; the updated copies of
files appeared in both /path_to_A and /path_to_B, and
creating/modifying/removing subsequent files continue to function as
expected.

I am attaching a (slightly sanitized for security reasons) log of the
event; it should show that 1) a number of files on both mounts indeed
differed; 2) unmounting then mounting the filesystem fixes the problem
(at least for now); and 3) the directory /path_to_B contained no files
when no loopback-mount was active.

Machine is a generic motherboard / Celeron 700 / 128MB RAM / 1.0GB swap.

Possible factors:  Until recently, httpd was not restarted often. 
Now, crond reloads httpd every five minutes ('service httpd reload').
 Apache uses the /var/www/htdocs/ directory.  (I need to use 'mount
--bind' because Apache only enables SuExec for files inside the
/var/www/htdocs directory)


Version-Release number of selected component (if applicable):
kernel-2.4.20-20.9  (uniprocessor version)

How reproducible:
Haven't been able to yet.  Will try on non-production systems.
Comment 1 Jeff Maurer 2004-05-24 04:20:52 EDT
Created attachment 100485 [details]
sanitized transcript of shell output for initial discovery of the problem
Comment 2 Jeff Maurer 2004-05-24 05:51:21 EDT
Ack, this machine is running Redhat 9.0 rather than FC1.  Kernel is
2.4.20-20.9.  
Comment 3 Bugzilla owner 2004-09-30 11:41:52 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.